<?php

/**
 * TODO do we really need to do this all the time? 
 */
$option = get_option( 'nktagcloud' );
$config = $option['config'];
if ( $config['homelink'] === 'No') {
	add_action('wp_footer', 'nktagcloud_footer');
}
if ( !( $config['rmcss'] === 'Yes' ) && ( $config['format'] === 'list' )) {
	add_action('wp_head', 'nktagcloud_head');      	
}

/**
 * The widget
 *
 * @param $args TODO
 */
function widget_nktagcloud($args) {
	extract($args);
	echo $before_widget;
	echo $before_title;
	$option = get_option('nktagcloud');
	$config = $option['config'];
	echo $config['title'];
	echo $after_title;
	echo nktagcloud_the_cloud($config);
	echo $after_widget;
}

/**
 * Output the tag cloud as configured
 *
 * @param array $option the plugin config
 *
 * @return string the tag cloud
 *
 * @since 0.8.1
 */
function nktagcloud_the_cloud($config) {
	$smallest	= $config['smallest'];
	$largest	= $config['largest'];
	$unit		= $config['unit'];
	$number		= $config['number'];
	$format		= $config['format'];
	$order		= $config['order'];
	$orderby	= $config['orderby'];
	$exclude	= $config['exclude'];
	$include	= $config['include'];
	if ( $config['replace'] == 'Yes' ) {
		add_filter('wp_tag_cloud', 'nktagcloud_replace_blanks');
	}
    return nk_wp_tag_cloud("largest=$largest&smallest=$smallest&unit=$unit&number=$number&format=$format&order=$order&orderby=$orderby&exclude=$exclude&include=$include");
}

/**
 * Convert blanks into &nbsp; to force tags on one line
 *
 * @param string $tag Some tag name
 * @return string The same tag without blanks
 */
function nktagcloud_replace_blanks( $tag ) {
	$tag = preg_replace('#(<a.+?>.+?) (.+</a>)#', '$1&nbsp;$2', $tag); #<? vim syntax highlighting..
	return $tag;
}

/**
 * Print the default CSS styles in the <head>
 *
 * @param string $underline TODO
 */
function nktagcloud_head($underline) { ?>
<style type="text/css">
.better-tag-cloud-shortcode li,
.better-tag-cloud-shortcode li a,
li#better-tag-cloud ul.wp-tag-cloud li,
li#better-tag-cloud ul.wp-tag-cloud li a {
	display:	inline;
	<?php
		if ($underline == 'none') {
			echo "text-decoration: none;";
		}
		elseif ($underline == 'underline') {
			echo "text-decoration: underline;";
		}
	?>
}
</style>
<?php
}

/**
 * Print the link to the plugin page
*/
# TODO rename function?
function nktagcloud_footer() {
	_e('<a href="http://www.nkuttler.de/wordpress/nktagcloud/">Better Tag Cloud</a>', 'nktagcloud' );
	echo '<br />';
}

/* This was copied from the wordpress source and modified, see 
 * wp-includes/category-template.php
*/

/**
 * Display tag cloud.
 *
 * The text size is set by the 'smallest' and 'largest' arguments, which will
 * use the 'unit' argument value for the CSS text size unit. The 'format'
 * argument can be 'flat' (default), 'list', or 'array'. The flat value for the
 * 'format' argument will separate tags with spaces. The list value for the
 * 'format' argument will format the tags in a UL HTML list. The array value for
 * the 'format' argument will return in PHP array type format.
 *
 * The 'orderby' argument will accept 'name' or 'count' and defaults to 'name'.
 * The 'order' is the direction to sort, defaults to 'ASC' and can be 'DESC'.
 *
 * The 'number' argument is how many tags to return. By default, the limit will
 * be to return the top 45 tags in the tag cloud list.
 *
 * The 'topic_count_text_callback' argument is a function, which, given the count
 * of the posts  with that tag, returns a text for the tooltip of the tag link.
 *
 * The 'exclude' and 'include' arguments are used for the {@link get_tags()}
 * function. Only one should be used, because only one will be used and the
 * other ignored, if they are both set.
 *
 * @since 2.3.0
 *
 * @param array|string $args Optional. Override default arguments.
 * @return array Generated tag cloud, only if no failures and 'array' is set for the 'format' argument.
 */
function nk_wp_tag_cloud( $args = '' ) {
    $defaults = array(
        'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 45,
        'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
        'exclude' => '', 'include' => '', 'link' => 'view'
    );
    $args = wp_parse_args( $args, $defaults );

    $tags = get_tags( array_merge( $args, array( 'orderby' => 'count', 'order' => 'DESC' ) ) ); // Always query top tags
	// nkuttler
	$option = get_option( 'nktagcloud' );
	if ( $option['config']['categories'] == 'Yes' ) {
		$tags = array_merge ( $tags, get_categories() );
	}

    if ( empty( $tags ) )
        return;

    foreach ( $tags as $key => $tag ) {
        if ( 'edit' == $args['link'] )
            $link = get_edit_tag_link( $tag->term_id );
        else
            $link = get_tag_link( $tag->term_id );
        if ( is_wp_error( $link ) )
            return false;

        $tags[ $key ]->link = $link;
        $tags[ $key ]->id = $tag->term_id;
    }
    
    $return = nk_wp_generate_tag_cloud( $tags, $args ); // Here's where those top tags get sorted according to $args

    $return = apply_filters( 'wp_tag_cloud', $return, $args );

    if ( 'array' == $args['format'] )
        return $return;

	// nkuttler - always return
	return $return;
    //echo $return;
}

/**
 * Generates a tag cloud (heatmap) from provided data.
 *
 * The text size is set by the 'smallest' and 'largest' arguments, which will
 * use the 'unit' argument value for the CSS text size unit. The 'format'
 * argument can be 'flat' (default), 'list', or 'array'. The flat value for the
 * 'format' argument will separate tags with spaces. The list value for the
 * 'format' argument will format the tags in a UL HTML list. The array value for
 * the 'format' argument will return in PHP array type format.
 *
 * The 'orderby' argument will accept 'name' or 'count' and defaults to 'name'.
 * The 'order' is the direction to sort, defaults to 'ASC' and can be 'DESC' or
 * 'RAND'.
 *
 * The 'number' argument is how many tags to return. By default, the limit will
 * be to return the entire tag cloud list.
 *
 * The 'topic_count_text_callback' argument is a function, which given the count
 * of the posts  with that tag returns a text for the tooltip of the tag link.
 *
 * @todo Complete functionality.
 * @since 2.3.0
 *
 * @param array $tags List of tags.
 * @param string|array $args Optional, override default arguments.
 * @return string
 */
function nk_wp_generate_tag_cloud( $tags, $args = '' ) {
	global $wp_rewrite;
	$defaults = array(
		'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 0,
		'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
		'topic_count_text_callback' => 'default_topic_count_text',
	);

	if ( !isset( $args['topic_count_text_callback'] ) && isset( $args['single_text'] ) && isset( $args['multiple_text'] ) ) {
		$body = 'return sprintf (
			__ngettext('.var_export($args['single_text'], true).', '.var_export($args['multiple_text'], true).', $count),
			number_format_i18n( $count ));';
		$args['topic_count_text_callback'] = create_function('$count', $body);
	}

	$args = wp_parse_args( $args, $defaults );

	extract( $args );

	if ( empty( $tags ) )
		return;

	// SQL cannot save you; this is a second (potentially different) sort on a subset of data.
	if ( 'name' == $orderby )
		uasort( $tags, create_function('$a, $b', 'return strnatcasecmp($a->name, $b->name);') );
	else
		uasort( $tags, create_function('$a, $b', 'return ($a->count > $b->count);') );

	if ( 'DESC' == $order )
		$tags = array_reverse( $tags, true );
	elseif ( 'RAND' == $order ) {
		$keys = array_rand( $tags, count( $tags ) );
		foreach ( $keys as $key )
			$temp[$key] = $tags[$key];
		$tags = $temp;
		unset( $temp );
	}

	/* nkuttler: support sorting by two criteria */
	$option = get_option( 'nktagcloud' );
	if ( $option['config']['order'] == 'both') {
		$orderby = 'both';
	}
	if ( 'both' == $orderby ) {
		function compare_both( $a, $b ) {
			$retval = strnatcmp( $b->count, $a->count );
			if( !$retval ) return strnatcmp( $a->name, $b->name );
			return $retval;
		} 
		usort( $tags, 'compare_both' );
	}
	/* end changes */

	if ( $number > 0 )
		$tags = array_slice($tags, 0, $number);

	$counts = array();
	foreach ( (array) $tags as $key => $tag )
		$counts[ $key ] = $tag->count;

	$min_count = min( $counts );
	$spread = max( $counts ) - $min_count;
	if ( $spread <= 0 )
		$spread = 1;
	$font_spread = $largest - $smallest;
	if ( $font_spread < 0 )
		$font_spread = 1;
	$font_step = $font_spread / $spread;

	$a = array();

	$rel = ( is_object( $wp_rewrite ) && $wp_rewrite->using_permalinks() ) ? ' rel="tag"' : '';

	/**
	 * Modifications my nkuttler
	 */

	 $option = get_option('nktagcloud');
	 $config = $option['config'];

	foreach ( $tags as $key => $tag ) {
		$count = $counts[ $key ];
		$tag_link = '#' != $tag->link ? clean_url( $tag->link ) : '#';
		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
		$tag_name = $tags[ $key ]->name;

		/**
		 * Modifications by nkuttler
		 * Check and print if we should print the tag counter, in- or outside the tag link
		 */
		if ( $config['inject_count_outside'] == 'Yes' ) {
			$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . attribute_escape( $topic_count_text_callback( $count ) ) . "'$rel style='font-size: " .  ( $smallest + ( ( $count - $min_count ) * $font_step ) ) . "$unit;'>$tag_name</a>" . '<span class="nktagcloud_counter">' . nktagcloud_add_counter( $tag, $config
			) . "</span>";
		}
		else {
			$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . attribute_escape( $topic_count_text_callback( $count ) ) . "'$rel style='font-size: " .  ( $smallest + ( ( $count - $min_count ) * $font_step ) ) . "$unit;'>$tag_name" . nktagcloud_add_counter( $tag, $config ) ."</a>";
		}
	}
	/* end changes */

	switch ( $format ) :
	case 'array' :
		$return =& $a;
		break;
	case 'list' :
		$return = "<ul class='wp-tag-cloud'>\n\t<li>";
		$return .= join( "</li>\n\t<li>", $a );
		$return .= "</li>\n</ul>\n";
		break;
	default :
		$return = join( "\n", $a );
		break;
	endswitch;

	return apply_filters( 'wp_generate_tag_cloud', $return, $tags, $args );
}

/*
 * Add a tag counter to the tags
 *
 * @param string $tag Tag
 */
function nktagcloud_add_counter( $tag, $config ) {
	if ( $config['inject_count'] == 'Yes' ) {
		$inject = '(' . $tag->count . ')';
		return $inject;
	}
}

?>
